#version 450

// ----------------------------------------------------------------------------
// Input Variables
// ----------------------------------------------------------------------------

layout(binding = 0) uniform sampler2D input_image;

// ----------------------------------------------------------------------------
// Output Variables
// ----------------------------------------------------------------------------

// The final output color.
layout(location = 0) out vec4 final_color;

// ----------------------------------------------------------------------------
// Local Variables
// ----------------------------------------------------------------------------

// Gaussian kernel
const float gaussBlurKernel[3][3] = {
	{1.0 / 16.0, 2.0 / 16.0, 1.0 / 16.0},
	{2.0 / 16.0, 4.0 / 16.0, 2.0 / 16.0},
	{1.0 / 16.0, 2.0 / 16.0, 1.0 / 16.0}
};

// Edge detection convolution kernel
const float edgeDetectionKernel[3][3] = {
	{-1.0, -1.0, -1.0},
	{-1.0,  8.0, -1.0},
	{-1.0, -1.0, -1.0}
};

// ----------------------------------------------------------------------------
// Main Method
// ----------------------------------------------------------------------------

void main() {
	//vec3 color  = texelFetch(input_image, ivec2(gl_FragCoord.xy)           , 0).rgb;
	//vec3 colorX = texelFetch(input_image, ivec2(gl_FragCoord.xy)+ivec2(1,0), 0).rgb;

	////float gray = 0.333*color.r + 0.333*color.g + 0.333*color.b;

	//final_color = vec4(10*(colorX-color), 1.0);

	vec3 color = texelFetch(input_image, ivec2(gl_FragCoord.xy), 0).rgb;
	final_color = vec4(color, 1.0);
}